package main

import (
	"encoding/json"
	"log"
	"io/ioutil"
	"os"

	"srs.epita.fr/fic-server/libfic"
)

type askOpenHint struct {
	HintId       int64 `json:"id"`
}

func treatOpeningHint(pathname string, team fic.Team) {
	var ask askOpenHint

	if cnt_raw, err := ioutil.ReadFile(pathname); err != nil {
		log.Println("[ERR]", err)
	} else if err := json.Unmarshal(cnt_raw, &ask); err != nil {
		log.Println("[ERR]", err)
	} else if ask.HintId == 0 {
		log.Println("[WRN] Invalid content in hint file: ", pathname)
		os.Remove(pathname)
	} else if hint, err := fic.GetHint(ask.HintId); err != nil {
		log.Println("[ERR]", err)
	} else if err := team.OpenHint(hint); err != nil {
		log.Println("[ERR]", err)
	} else {
		genTeamMyFile(team)
		if err := os.Remove(pathname); err != nil {
			log.Println("[ERR]", err)
		}
	}
}
